Imports Microsoft.VisualBasic
Imports System
Namespace Domain
	Public Class Money
		Private ReadOnly amount As Decimal

		Public Sub New(ByVal value As Decimal)
			Me.amount = value

		End Sub

		Public Shared Operator +(ByVal money1 As Money, ByVal money2 As Money) As Money
			Return New Money(money1.amount + money2.amount)
		End Operator

		Public Overrides Function ToString() As String
			Return amount.ToString()
		End Function

		Public Overrides Overloads Function Equals(ByVal obj As Object) As Boolean
			Dim otherAmount = TryCast(obj, Money)
			If otherAmount Is Nothing Then
				Return False
			End If
			Return amount = otherAmount.amount
		End Function

		Public Overrides Function GetHashCode() As Integer
			Return amount.GetHashCode()
		End Function
	End Class
End Namespace