Imports Microsoft.VisualBasic
Imports System
Namespace Domain
	Public Class Quantity
		Private ReadOnly value As Integer

		Public Sub New(ByVal qty As Integer)
			Me.value = qty
		End Sub

		Public Overrides Function ToString() As String
			Return value.ToString()
		End Function

		Public Overrides Overloads Function Equals(ByVal obj As Object) As Boolean
			Dim otherQty = TryCast(obj, Quantity)
			If otherQty Is Nothing Then
				Return False
			End If
            Return value = otherQty.value
		End Function

		Public Overrides Function GetHashCode() As Integer
			Return value.GetHashCode()
		End Function
	End Class
End Namespace