Imports Microsoft.VisualBasic
Imports System
Imports developwithpassion.bdd.contexts
Imports developwithpassion.bdd.mbunit
Imports developwithpassion.bdd.mbunit.standard.observations

Namespace Domain.Specs
	Public Class MoneySpecs
		Public Class concern
			Inherits observations_for_a_static_sut
		End Class

		Public Class when_added_to_another_money
			Inherits concern
            Private should_result_in_a_money_that_represents_the_sum As it = AddressOf should_result_in_a_money_that_represents_the_sum_check
            Private Sub should_result_in_a_money_that_represents_the_sum_check()
                Dim twoDollars = New Money(2D)
                Dim threeDollars = New Money(3D)
                Dim fiveDollars = New Money(5D)
                Dim result = twoDollars + threeDollars
                result.should_be_equal_to(fiveDollars)
            End Sub

		End Class
	End Class
End Namespace